// virtasm.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;
/*
MOV AX, 3
MOV BX, 10
MOV CX, 0
MOV DX, 1
CMP CX, BX
JIE 10
ADD CX, 1
PTF DX
MUL DX, AX
JMP 4
PTF DX
END 
*/

#pragma pack (1)
union Command
{
  struct
  {
	//3  - , 1 -  , 3 -  , 8 -  .
	unsigned int cmdType:   3;
	unsigned int addrTypeA: 1;
	unsigned int regTypeA:  3;
	unsigned int addrTypeB: 1;
	unsigned int regTypeB:  8;	
  };
  short int command;
};
#pragma pack ()

///////////////////////////////////////////////////
class Translator
{
	private:		
		vector<std::string> Lexems;
		vector<std::string> Regisrs;
		
		

	public:
	Translator()
	{		

		Lexems.push_back ("MOV");		
		Lexems.push_back ("CMP");
		Lexems.push_back ("JIE");
		Lexems.push_back ("JMP");
		Lexems.push_back ("PTF");
		Lexems.push_back ("ADD");
		Lexems.push_back ("MUL");
		Lexems.push_back ("END");

		Regisrs.push_back ("AX");
		Regisrs.push_back ("BX");
		Regisrs.push_back ("CX");
		Regisrs.push_back ("DX");
	}

	int	translate (ifstream &fileIn, ofstream &fileOut)
	{		
		string line;
		getline (fileIn, line);
		while (!fileIn.eof ())
		{
			
			int pos=0;
			int lexem = get_lexem(line, &pos);
			//cout<<lexem;
			if (lexem)
				switch(lexem)
				{
					case 1: //MOV
						write_double_parametrs(lexem ,line, pos, fileOut);
					break;

					case 2: //CMP						
						write_double_parametrs(lexem ,line, pos, fileOut);
					break;

					case 3: //JIE
						write_single_parametrs(lexem ,line, pos, fileOut);
					break;

					case 4: //JMP
						write_single_parametrs(lexem ,line, pos, fileOut);
					break;

					case 5: //PTF
						write_single_parametrs(lexem ,line, pos, fileOut);
					break;

					case 6: //ADD						
						write_double_parametrs(lexem ,line, pos, fileOut);
					break;

					case 7: //MUL	
						write_double_parametrs(lexem ,line, pos, fileOut);
					break;

					default:
						cout<<"unknown lexem";
				}
			getline (fileIn, line);
		}
		return 1;
	}


	int write_single_parametrs(int lexem, string line, int pos, ofstream &fileOut)
	{

			int registr_type1, registr_type2;
			int addr1_type, addr2_type;
			
			addr1_type = 0; addr2_type = 0;
			registr_type1 = get_registr(line, &pos);
			//pos++; //','
			//registr_type2 = get_registr(line, &pos);

			string number="  ";
			if (registr_type1 == -1)
			{
				addr1_type = 1;
				
				int k=0;
				for (int j = pos-2; j<min<int>(pos,line.length()); j++)
					{
						number[k] = line[j];
						k++;
					}							
				registr_type1 = atoi(number.c_str());
			}

			//cout<<number<<endl;
			//cout<<lexem<<" "<<addr1_type<<" "<<registr_type1<<" "<<" "<<addr2_type<<" "<<registr_type2<<endl;
			Command cmd;						
			cmd.cmdType = lexem;
			cmd.addrTypeA = 0;
			cmd.regTypeA = 0;
			cmd.addrTypeB = addr1_type;
			cmd.regTypeB = registr_type1;
			/*cout<<cmd.cmdType<<endl;
			cout<<cmd.addrTypeA<<endl;
			cout<<cmd.regTypeA<<endl;
			cout<<cmd.addrTypeB<<endl;
			cout<<cmd.regTypeB<<endl;
			cout<<"======command========"<<endl;*/
			fileOut.write((char *)&cmd.command, sizeof(cmd.command));	
			//out.write ((char*)&cmd.command, sizeof (cmd.command));
			return 1;
	}

	int write_double_parametrs(int lexem, string line, int pos, ofstream &fileOut)
	{

			int registr_type1, registr_type2;
			int addr1_type, addr2_type;
			
			addr1_type = 0; addr2_type = 0;
			registr_type1 = get_registr(line, &pos);
			pos++; //','
			registr_type2 = get_registr(line, &pos);

			string number="  ";
			if (registr_type2 == -1)
			{
				addr2_type = 1;
				
				int k=0;
				for (int j = pos-2; j<min<int>(pos,line.length()); j++)
					{
						number[k] = line[j];
						k++;
					}							
				registr_type2 = atoi(number.c_str());
			}

			//cout<<lexem<<" "<<addr1_type<<" "<<registr_type1<<" "<<" "<<addr2_type<<" "<<registr_type2<<endl;
			Command cmd;						
			cmd.cmdType = lexem;
			cmd.addrTypeA = addr1_type;
			cmd.regTypeA = registr_type1;
			cmd.addrTypeB = addr2_type;
			cmd.regTypeB = registr_type2;
			/*cout<<cmd.cmdType<<endl;
			cout<<cmd.addrTypeA<<endl;
			cout<<cmd.regTypeA<<endl;
			cout<<cmd.addrTypeB<<endl;
			cout<<cmd.regTypeB<<endl;
			cout<<"======command========"<<endl;*/
			fileOut.write((char *)&cmd.command, sizeof(cmd.command));	
			return 1;
	}

	int get_lexem (string line, int *pos)
	{
		
		return get_digits_name(line,pos,3,Lexems);
	}

	int get_registr (string line, int *pos)
	{		
		return get_digits_name(line,pos,2,Regisrs);		

	}

	int get_digits_name(string line, int *pos, int length, vector<std::string> Vec)
	{
		
		string name="   ";
		name.resize(length);
		int j,i=*pos;
		while(line[i]==' ') i++;
		for(j=0; j<length; j++)
		{
			name[j] = line[i+j];			
		}
		*pos = j+i;
		name[j] = '\0';
		//cout<<"'"<<Vec[0]<<"'   '"<<name<<"'"<<endl;
		for(int j=0; j<Vec.size(); j++)
		{
			if (Vec[j] == name)
			{return j+1;}
		}		
		return -1;
	}
};



///////////////////////////////////////////////////

class Machine
{
	private:
		vector<std::string> Regisrs;
		int registrs[6];// XX,AX,BX,CX,DX; //unknown error if there will not be 6;
		string memory;

		int analyse_command(Command cmd, ifstream &fileIn)
		{
			switch (cmd.cmdType)
			{
				case 1://MOV
					if (cmd.addrTypeB == 0) 
						registrs[cmd.regTypeA+1] = registrs[cmd.regTypeB+1];
					else registrs[cmd.regTypeA+1] = cmd.regTypeB;
				break;

				case 2://CMP
					int first,second;
					first = registrs[cmd.regTypeA+1];
					if (cmd.addrTypeB == 0) 
						second = registrs[cmd.regTypeB+1];
					else second = cmd.regTypeB;

					if (first==second)
						registrs[0] = 0;
					if (first>second)
						registrs[0] = 1;
					if (first<second)
						registrs[0] = 2;
				break;

				case 3://JIE
					if (registrs[0]==0)
					{
						char tmpBuffer[256];
						fileIn.seekg (0, ios::beg);
						if (cmd.addrTypeB == 0)
							fileIn.read(tmpBuffer, 2*registrs[cmd.regTypeB+1]);	
						else fileIn.read(tmpBuffer, 2*(cmd.regTypeB));
					}
				break;

				case 4://JMP
						char tmpBuffer[256];
						fileIn.seekg (0, ios::beg);
						if (cmd.addrTypeB == 0)
							fileIn.read(tmpBuffer, 2*registrs[cmd.regTypeB+1]);	
						else fileIn.read(tmpBuffer, 2*(cmd.regTypeB));					
				break;

				case 5://PTF
						if (cmd.addrTypeB == 0)
							cout<<registrs[cmd.regTypeB+1]<<endl;	
						else cout<<cmd.regTypeB<<endl;						
				break;

				case 6://ADD
						if (cmd.addrTypeB == 0) 
							registrs[cmd.regTypeA+1] += registrs[cmd.regTypeB+1];
						else registrs[cmd.regTypeA+1] += cmd.regTypeB;
				break;

				case 7://MUL
						if (cmd.addrTypeB == 0) 
							registrs[cmd.regTypeA+1] *= registrs[cmd.regTypeB+1];
						else registrs[cmd.regTypeA+1] *= cmd.regTypeB;
				break;
			}
			return 1;
		}
	public:
	Machine(){
		Regisrs.push_back ("AX");
		Regisrs.push_back ("BX");
		Regisrs.push_back ("CX");
		Regisrs.push_back ("DX");		
	}
	int execute(ifstream &fileIn)
	{
		fileIn.seekg (0, ios::beg);
		
		//fileIn.read (buffer, bufferSize);
		Command cmd;
		fileIn.read ((char*)&cmd.command, sizeof (cmd.command));


		
		while (!fileIn.eof ())
		{
			
			/*cout<<cmd.cmdType<<endl;
			cout<<cmd.addrTypeA<<endl;
			cout<<cmd.regTypeA<<endl;
			cout<<cmd.addrTypeB<<endl;
			cout<<cmd.regTypeB<<endl;
			cout<<"======command========"<<endl;*/			
			analyse_command(cmd, fileIn);

			//memory += cmd.command;
			fileIn.read ((char*)&cmd.command, sizeof (cmd.command));			
		}
		//cmd.command = memory.c_str()[0]+memory.c_str()[1];
		//cout<<cmd.regTypeB;
		return 0;
	}
	~Machine(){}
};


int _tmain(int argc, _TCHAR* argv[])
{
	ifstream fileIn ("input.code");
	ofstream fileOut ("output.bin", ios::binary);

	
	Translator T;
	cout<<"Translator is Working..."<<endl;
	T.translate (fileIn, fileOut);
	cout<<"Translator complete."<<endl;
	fileOut.close();
	cout<<"Machine is Working..."<<endl;

	ifstream fileMachine ("output.bin", ios::binary);
	Machine M;
	M.execute(fileMachine);
	fileMachine.close();
	cout<<"Machine complete."<<endl;
	
	return 0;
}

